package de.tu_darmstadt.tk.SmartHomeNetworkSim.view.popups;

import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultMutableTreeNode;

import de.tu_darmstadt.tk.SmartHomeNetworkSim.control.Controller;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.Connection;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.Link;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.Port;

import java.awt.Dimension;

public class NetworkTreePanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 6946547116132845220L;

	public NetworkTreePanel(Controller c) {
		
		JTree tree = new JTree();
		tree.setPreferredSize(new Dimension(400, 600));
		tree.setMaximumSize(new Dimension(600, 1000));
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Network");
		for(Link l: c.getLinks()){
			DefaultMutableTreeNode link = new DefaultMutableTreeNode(l.getName());
			for(Connection con: c.getConnections()){
				if(!l.getConnections().contains(con))continue;
				DefaultMutableTreeNode connection = new DefaultMutableTreeNode(con.getName());
				for(Port p:con.getParticipants()){
					if(!l.getDevices().contains(p.getOwner())||!con.getParticipants().contains(p))continue;
					DefaultMutableTreeNode port = new DefaultMutableTreeNode(p.getOwner().getName());
					connection.add(port);
				}
				link.add(connection);
			}
			root.add(link);
		}
		DefaultTreeModel model = new DefaultTreeModel(root);
		tree.setModel(model);
		add(tree);
	}

}
